setInterval(function() {
    const player = document.querySelector('.video-stream.html5-main-video');
    if (player) {
        player.muted = true;
        player.currentTime = 0;
        player.pause();
    }
}, 500);

setInterval(function() {
    const videoItems = document.querySelectorAll('ytm-rich-item-renderer, ytm-video-with-context-renderer, ytm-media-item, ytm-video-card-renderer, ytm-playlist-video-renderer, .amsterdam-playlist-thumbnail-wrapper, ytm-compact-video-renderer, .video-preview, ytm-shorts-lockup-view-model');
    
    videoItems.forEach(function(videoItem) {
        const newVideoItem = videoItem.cloneNode(true);
        videoItem.parentNode.replaceChild(newVideoItem, videoItem);

        // Restore thumbnails
        const videoLink = newVideoItem.querySelector('a');
        if (videoLink) {
            let videoId = new URL(videoLink.href).searchParams.get('v');
            // Short videos have a different URL structure
            if (!videoId) {
                const videoIdShorts = videoLink.href.split('/').pop();
                if (videoIdShorts && videoIdShorts.length === 11) {
                    videoId = videoIdShorts;
                }
            }

            if (videoId) {
                const thumbnailUrl = `https://i.ytimg.com/vi/${videoId}/hq720.jpg`;
                const videoThumbnailImg = newVideoItem.querySelector('img.video-thumbnail-img');
                if (videoThumbnailImg) {
                    videoThumbnailImg.src = thumbnailUrl;
                    videoThumbnailImg.classList.add('yt-core-image--loaded');
                }
            }
        }

        newVideoItem.addEventListener('click', function(e) {
            // normal flow for channels and action buttons
            if (e.target.parentElement.classList.contains('channel-thumbnail-icon') ||
                e.target.classList.contains('icon-button ')) {
                return;
            }

            e.preventDefault();
            e.stopPropagation();

            const videoLink = newVideoItem.querySelector('a');
            openVideo(videoLink.href);
        });

        const videoThumbnailImg = newVideoItem.querySelector('.video-thumbnail-img');
        if (videoThumbnailImg) {
            videoThumbnailImg.addEventListener('click', function(e) {
                e.preventDefault();
                e.stopPropagation();

                const videoLink = newVideoItem.querySelector('a');
                openVideo(videoLink.href);
            });
        }
    });
}, 600);